# KLab

This library was generated with [Angular CLI](https://github.com/angular/angular-cli) version 12.2.0.

K-Lab dropdown for without checkbox, with checkbox of single select and multi select. Implemented inbuilt search options.
## Requirements

For development, you will only need Node.js installed in your environement.

## Installation
    npm intall k-lab

## configuration
To load Modules in your environment,
```bash
    import { KLabModule } from 'k-lab'
    @NgModule({
        [...],
        imports: [KLabModule]
    })
```
    
## Documentation
### Step 1

    <k-lab-dropdown [data]="data" (kDropdownEvent)="selectedValues($event)"></k-lab-dropdown>
-   Send data as Array (Required)
-   Event is any method (Required)

Data Config :

    data: any = {
        list: ["anyName1", "anyName2"] | [{"name": "Doe"}] | Required,
        selectedValue: 'select value | any string' | Required,
        nameToBind: 'name | property to bind in the options',
        enableToCheckbox: 'default | single | multi',
        withSearchOf: true | default to false
    };

Event :

Pass eventEmitter method to return selected options.

    selectedValues(evt: any) {
        console.log('selected values', evt);
    }


