(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('k-lab', ['exports', '@angular/core', '@angular/platform-browser', '@angular/forms', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["k-lab"] = {}, global.ng.core, global.ng.platformBrowser, global.ng.forms, global.ng.common));
})(this, (function (exports, i0, platformBrowser, i2, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    var KLabService = /** @class */ (function () {
        function KLabService() {
        }
        return KLabService;
    }());
    KLabService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    KLabService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () { return []; } });

    var KLabComponent = /** @class */ (function () {
        function KLabComponent() {
        }
        KLabComponent.prototype.ngOnInit = function () {
        };
        return KLabComponent;
    }());
    KLabComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    KLabComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: KLabComponent, selector: "lib-kLab", ngImport: i0__namespace, template: "\n    <p>\n      k-lab works!\n    </p>\n  ", isInline: true });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-kLab',
                        template: "\n    <p>\n      k-lab works!\n    </p>\n  ",
                        styles: []
                    }]
            }], ctorParameters: function () { return []; } });

    var KLabDropdownComponent = /** @class */ (function () {
        function KLabDropdownComponent() {
            this.kDropdownEvent = new i0.EventEmitter();
            this.selectedValue = '';
            this.dropDownList = [];
            this.isOptionsShowing = false;
            this.enableToCheckbox = 'default';
            this.withSearchOf = false;
            this.search = '';
            this.nameToBind = 'name';
            this.selectedValue = 'select value';
            this.assignClassesToDropdown();
        }
        KLabDropdownComponent.prototype.ngOnInit = function () {
            var _a, _b, _c, _d, _e, _f;
            this.dropDownList = ((_b = (_a = this.data) === null || _a === void 0 ? void 0 : _a.list) === null || _b === void 0 ? void 0 : _b.length) > 0 ? this.data.list : [];
            this.selectedValue = ((_c = this.data) === null || _c === void 0 ? void 0 : _c.selectedValue) ? this.data.selectedValue : 'Select option';
            this.enableToCheckbox = ((_d = this.data) === null || _d === void 0 ? void 0 : _d.enableToCheckbox) ? this.data.enableToCheckbox : false;
            this.withSearchOf = ((_e = this.data) === null || _e === void 0 ? void 0 : _e.withSearchOf) ? this.data.withSearchOf : false;
            this.nameToBind = ((_f = this.data) === null || _f === void 0 ? void 0 : _f.nameToBind) ? this.data.nameToBind : '';
            this.setCheckboxes();
        };
        KLabDropdownComponent.prototype.setCheckboxes = function () {
            var dlist = [];
            for (var i = 0; i < this.dropDownList.length; i++) {
                if (typeof this.dropDownList[i] == 'string') {
                    dlist.push({
                        isChecked: false,
                        name: this.dropDownList[i]
                    });
                }
                else {
                    this.dropDownList[i]['isChecked'] = false;
                    dlist.push(this.dropDownList[i]);
                }
            }
            this.dropDownList = dlist;
        };
        KLabDropdownComponent.prototype.assignClassesToDropdown = function () {
            var _a, _b, _c, _d;
            var classList = ((_b = (_a = this.data) === null || _a === void 0 ? void 0 : _a.options) === null || _b === void 0 ? void 0 : _b.classList) ? (_d = (_c = this.data) === null || _c === void 0 ? void 0 : _c.options) === null || _d === void 0 ? void 0 : _d.classList : {};
        };
        KLabDropdownComponent.prototype.openDropdownOptions = function () {
            this.isOptionsShowing = !this.isOptionsShowing;
        };
        KLabDropdownComponent.prototype.clickEventOnOptions = function (option) {
            var data = [];
            if (this.enableToCheckbox == 'single') {
                for (var i = 0; i < this.dropDownList.length; i++) {
                    if (this.dropDownList[i][this.nameToBind] == option[this.nameToBind]) {
                        this.dropDownList[i].isChecked = !option.isChecked;
                    }
                    else {
                        this.dropDownList[i].isChecked = false;
                    }
                }
                this.selectedValue = option[this.nameToBind];
                this.dropDownList.forEach(function (val) {
                    var obj = Object.assign({}, val);
                    if (obj.isChecked) {
                        delete obj.isChecked;
                        data.push(obj);
                    }
                });
            }
            else if (this.enableToCheckbox == 'multi') {
                option.isChecked = !option.isChecked;
                this.selectedValue = option[this.nameToBind];
                this.dropDownList.forEach(function (val) {
                    var obj = Object.assign({}, val);
                    if (obj.isChecked) {
                        delete obj.isChecked;
                        data.push(obj);
                    }
                });
            }
            else {
                this.isOptionsShowing = false;
                this.selectedValue = option[this.nameToBind];
                this.dropDownList.forEach(function (val) {
                    var obj = Object.assign({}, val);
                    if (obj.isChecked) {
                        delete obj.isChecked;
                        data.push(obj);
                    }
                });
            }
            this.kDropdownEvent.emit({ data: data });
        };
        KLabDropdownComponent.prototype.dropdownSearch = function () {
            var _this = this;
            var _a, _b, _c, _d;
            this.dropDownList = ((_b = (_a = this.data) === null || _a === void 0 ? void 0 : _a.list) === null || _b === void 0 ? void 0 : _b.length) > 0 ? this.data.list : [];
            this.setCheckboxes();
            if (this.dropDownList) {
                var dropdownList = [];
                for (var i = 0; i < this.dropDownList.length; i++) {
                    dropdownList = this.dropDownList.filter(function (val) {
                        var propStr = '';
                        for (var prop in val) {
                            if (prop != 'isChecked') {
                                propStr += val[prop];
                            }
                        }
                        var oUpper = propStr ? propStr.replace(/ /g, '').toUpperCase() : '';
                        var sUpper = _this.search ? _this.search.replace(/ /g, '').toUpperCase() : '';
                        return oUpper ? oUpper.indexOf(sUpper) != -1 : false;
                    });
                }
                if (dropdownList.length > 0) {
                    this.dropDownList = dropdownList;
                }
                else {
                    this.dropDownList = ((_d = (_c = this.data) === null || _c === void 0 ? void 0 : _c.list) === null || _d === void 0 ? void 0 : _d.length) > 0 ? this.data.list : [];
                    this.setCheckboxes();
                }
            }
        };
        return KLabDropdownComponent;
    }());
    KLabDropdownComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabDropdownComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    KLabDropdownComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: KLabDropdownComponent, selector: "k-lab-dropdown", inputs: { data: "data" }, outputs: { kDropdownEvent: "kDropdownEvent" }, ngImport: i0__namespace, template: "<div class=\"k-dropdown-menu\">\n    <div class=\"k-dropdown-selected\" (click)=\"openDropdownOptions()\"> {{selectedValue}} </div>\n    <div class=\"k-dropdown-options\" *ngIf=\"isOptionsShowing\">\n        <div *ngIf=\"withSearchOf\" class=\"k-dropdown-search\">\n            <input type=\"text\" (keyup)=\"dropdownSearch()\" [(ngModel)]=\"search\" class=\"k-dropdown-search-input\" placeholder=\"search options\">\n        </div>\n        <div *ngFor=\"let item of dropDownList;\" (click)=\"clickEventOnOptions(item)\" class=\"k-dropdown-option\">\n            <span *ngIf=\"enableToCheckbox == 'default'\">{{item.value}}</span>\n            <div *ngIf=\"enableToCheckbox == 'single' || enableToCheckbox == 'multi'\" class=\"k-dropdown-checkbox\"> \n                <span class=\"k-dropdown-content\">{{item[nameToBind]}}</span> \n                <input class=\"k-dropdown-input-checkbox\" [(ngModel)]=\"item.isChecked\" type=\"checkbox\"> \n            </div>\n        </div>\n    </div>\n</div>", styles: [".k-dropdown-menu{width:100%;position:relative}.k-dropdown-selected{background:#fff;padding:.6%;text-align:center;border-bottom:1px solid #170f9080;border-top:1px solid #170f9033;border-left:1px solid #170f9033;border-right:1px solid #170f9033}.k-dropdown-options{background:#fff;margin-top:2px;position:absolute;box-shadow:0 8px 16px #0003;z-index:1;width:100%;border-bottom:1px solid #170f9033;border-left:1px solid #170f9033;border-right:1px solid #170f9033;border-top:1px solid #170f9033}.k-dropdown-option{padding:4px 0;text-align:center;height:32px}.k-dropdown-option:hover{background:#170cbe7a;color:#fff}.k-dropdown-checkbox{width:100%;height:32px}.k-dropdown-content{width:78%;float:left}.k-dropdown-input-checkbox{width:18%;float:left}.k-dropdown-search{border-bottom:1px solid #170f9033;width:100%}.k-dropdown-search-input{padding:0!important;width:100%;border:none;min-height:28px;text-align:center}.k-dropdown-search-input:focus{outline:none}\n"], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2__namespace.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2__namespace.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabDropdownComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'k-lab-dropdown',
                        templateUrl: './k-lab-dropdown.component.html',
                        styleUrls: ['./k-lab-dropdown.component.css']
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { data: [{
                    type: i0.Input
                }], kDropdownEvent: [{
                    type: i0.Output
                }] } });

    var KLabModule = /** @class */ (function () {
        function KLabModule() {
        }
        return KLabModule;
    }());
    KLabModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    KLabModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabModule, declarations: [KLabComponent,
            KLabDropdownComponent], imports: [platformBrowser.BrowserModule,
            i2.FormsModule], exports: [KLabComponent,
            KLabDropdownComponent] });
    KLabModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabModule, imports: [[
                platformBrowser.BrowserModule,
                i2.FormsModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: KLabModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            KLabComponent,
                            KLabDropdownComponent
                        ],
                        imports: [
                            platformBrowser.BrowserModule,
                            i2.FormsModule
                        ],
                        exports: [
                            KLabComponent,
                            KLabDropdownComponent
                        ]
                    }]
            }] });

    /*
     * Public API Surface of k-lab
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.KLabComponent = KLabComponent;
    exports.KLabDropdownComponent = KLabDropdownComponent;
    exports.KLabModule = KLabModule;
    exports.KLabService = KLabService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=k-lab.umd.js.map
