import * as i0 from '@angular/core';
import { Injectable, Component, EventEmitter, Input, Output, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import * as i2 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i1 from '@angular/common';

class KLabService {
    constructor() { }
}
KLabService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
KLabService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class KLabComponent {
    constructor() { }
    ngOnInit() {
    }
}
KLabComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
KLabComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: KLabComponent, selector: "lib-kLab", ngImport: i0, template: `
    <p>
      k-lab works!
    </p>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-kLab',
                    template: `
    <p>
      k-lab works!
    </p>
  `,
                    styles: []
                }]
        }], ctorParameters: function () { return []; } });

class KLabDropdownComponent {
    constructor() {
        this.kDropdownEvent = new EventEmitter();
        this.selectedValue = '';
        this.dropDownList = [];
        this.isOptionsShowing = false;
        this.enableToCheckbox = 'default';
        this.withSearchOf = false;
        this.search = '';
        this.nameToBind = 'name';
        this.selectedValue = 'select value';
        this.assignClassesToDropdown();
    }
    ngOnInit() {
        var _a, _b, _c, _d, _e, _f;
        this.dropDownList = ((_b = (_a = this.data) === null || _a === void 0 ? void 0 : _a.list) === null || _b === void 0 ? void 0 : _b.length) > 0 ? this.data.list : [];
        this.selectedValue = ((_c = this.data) === null || _c === void 0 ? void 0 : _c.selectedValue) ? this.data.selectedValue : 'Select option';
        this.enableToCheckbox = ((_d = this.data) === null || _d === void 0 ? void 0 : _d.enableToCheckbox) ? this.data.enableToCheckbox : false;
        this.withSearchOf = ((_e = this.data) === null || _e === void 0 ? void 0 : _e.withSearchOf) ? this.data.withSearchOf : false;
        this.nameToBind = ((_f = this.data) === null || _f === void 0 ? void 0 : _f.nameToBind) ? this.data.nameToBind : '';
        this.setCheckboxes();
    }
    setCheckboxes() {
        let dlist = [];
        for (let i = 0; i < this.dropDownList.length; i++) {
            if (typeof this.dropDownList[i] == 'string') {
                dlist.push({
                    isChecked: false,
                    name: this.dropDownList[i]
                });
            }
            else {
                this.dropDownList[i]['isChecked'] = false;
                dlist.push(this.dropDownList[i]);
            }
        }
        this.dropDownList = dlist;
    }
    assignClassesToDropdown() {
        var _a, _b, _c, _d;
        let classList = ((_b = (_a = this.data) === null || _a === void 0 ? void 0 : _a.options) === null || _b === void 0 ? void 0 : _b.classList) ? (_d = (_c = this.data) === null || _c === void 0 ? void 0 : _c.options) === null || _d === void 0 ? void 0 : _d.classList : {};
    }
    openDropdownOptions() {
        this.isOptionsShowing = !this.isOptionsShowing;
    }
    clickEventOnOptions(option) {
        let data = [];
        if (this.enableToCheckbox == 'single') {
            for (let i = 0; i < this.dropDownList.length; i++) {
                if (this.dropDownList[i][this.nameToBind] == option[this.nameToBind]) {
                    this.dropDownList[i].isChecked = !option.isChecked;
                }
                else {
                    this.dropDownList[i].isChecked = false;
                }
            }
            this.selectedValue = option[this.nameToBind];
            this.dropDownList.forEach((val) => {
                let obj = Object.assign({}, val);
                if (obj.isChecked) {
                    delete obj.isChecked;
                    data.push(obj);
                }
            });
        }
        else if (this.enableToCheckbox == 'multi') {
            option.isChecked = !option.isChecked;
            this.selectedValue = option[this.nameToBind];
            this.dropDownList.forEach((val) => {
                let obj = Object.assign({}, val);
                if (obj.isChecked) {
                    delete obj.isChecked;
                    data.push(obj);
                }
            });
        }
        else {
            this.isOptionsShowing = false;
            this.selectedValue = option[this.nameToBind];
            this.dropDownList.forEach((val) => {
                let obj = Object.assign({}, val);
                if (obj.isChecked) {
                    delete obj.isChecked;
                    data.push(obj);
                }
            });
        }
        this.kDropdownEvent.emit({ data: data });
    }
    dropdownSearch() {
        var _a, _b, _c, _d;
        this.dropDownList = ((_b = (_a = this.data) === null || _a === void 0 ? void 0 : _a.list) === null || _b === void 0 ? void 0 : _b.length) > 0 ? this.data.list : [];
        this.setCheckboxes();
        if (this.dropDownList) {
            let dropdownList = [];
            for (let i = 0; i < this.dropDownList.length; i++) {
                dropdownList = this.dropDownList.filter((val) => {
                    let propStr = '';
                    for (let prop in val) {
                        if (prop != 'isChecked') {
                            propStr += val[prop];
                        }
                    }
                    let oUpper = propStr ? propStr.replace(/ /g, '').toUpperCase() : '';
                    let sUpper = this.search ? this.search.replace(/ /g, '').toUpperCase() : '';
                    return oUpper ? oUpper.indexOf(sUpper) != -1 : false;
                });
            }
            if (dropdownList.length > 0) {
                this.dropDownList = dropdownList;
            }
            else {
                this.dropDownList = ((_d = (_c = this.data) === null || _c === void 0 ? void 0 : _c.list) === null || _d === void 0 ? void 0 : _d.length) > 0 ? this.data.list : [];
                this.setCheckboxes();
            }
        }
    }
}
KLabDropdownComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabDropdownComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
KLabDropdownComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: KLabDropdownComponent, selector: "k-lab-dropdown", inputs: { data: "data" }, outputs: { kDropdownEvent: "kDropdownEvent" }, ngImport: i0, template: "<div class=\"k-dropdown-menu\">\n    <div class=\"k-dropdown-selected\" (click)=\"openDropdownOptions()\"> {{selectedValue}} </div>\n    <div class=\"k-dropdown-options\" *ngIf=\"isOptionsShowing\">\n        <div *ngIf=\"withSearchOf\" class=\"k-dropdown-search\">\n            <input type=\"text\" (keyup)=\"dropdownSearch()\" [(ngModel)]=\"search\" class=\"k-dropdown-search-input\" placeholder=\"search options\">\n        </div>\n        <div *ngFor=\"let item of dropDownList;\" (click)=\"clickEventOnOptions(item)\" class=\"k-dropdown-option\">\n            <span *ngIf=\"enableToCheckbox == 'default'\">{{item.value}}</span>\n            <div *ngIf=\"enableToCheckbox == 'single' || enableToCheckbox == 'multi'\" class=\"k-dropdown-checkbox\"> \n                <span class=\"k-dropdown-content\">{{item[nameToBind]}}</span> \n                <input class=\"k-dropdown-input-checkbox\" [(ngModel)]=\"item.isChecked\" type=\"checkbox\"> \n            </div>\n        </div>\n    </div>\n</div>", styles: [".k-dropdown-menu{width:100%;position:relative}.k-dropdown-selected{background:#fff;padding:.6%;text-align:center;border-bottom:1px solid #170f9080;border-top:1px solid #170f9033;border-left:1px solid #170f9033;border-right:1px solid #170f9033}.k-dropdown-options{background:#fff;margin-top:2px;position:absolute;box-shadow:0 8px 16px #0003;z-index:1;width:100%;border-bottom:1px solid #170f9033;border-left:1px solid #170f9033;border-right:1px solid #170f9033;border-top:1px solid #170f9033}.k-dropdown-option{padding:4px 0;text-align:center;height:32px}.k-dropdown-option:hover{background:#170cbe7a;color:#fff}.k-dropdown-checkbox{width:100%;height:32px}.k-dropdown-content{width:78%;float:left}.k-dropdown-input-checkbox{width:18%;float:left}.k-dropdown-search{border-bottom:1px solid #170f9033;width:100%}.k-dropdown-search-input{padding:0!important;width:100%;border:none;min-height:28px;text-align:center}.k-dropdown-search-input:focus{outline:none}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabDropdownComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'k-lab-dropdown',
                    templateUrl: './k-lab-dropdown.component.html',
                    styleUrls: ['./k-lab-dropdown.component.css']
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { data: [{
                type: Input
            }], kDropdownEvent: [{
                type: Output
            }] } });

class KLabModule {
}
KLabModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
KLabModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabModule, declarations: [KLabComponent,
        KLabDropdownComponent], imports: [BrowserModule,
        FormsModule], exports: [KLabComponent,
        KLabDropdownComponent] });
KLabModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabModule, imports: [[
            BrowserModule,
            FormsModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: KLabModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        KLabComponent,
                        KLabDropdownComponent
                    ],
                    imports: [
                        BrowserModule,
                        FormsModule
                    ],
                    exports: [
                        KLabComponent,
                        KLabDropdownComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of k-lab
 */

/**
 * Generated bundle index. Do not edit.
 */

export { KLabComponent, KLabDropdownComponent, KLabModule, KLabService };
//# sourceMappingURL=k-lab.js.map
